// tmtlib@narod.ru

unit mystrtool;

interface

uses SysUtils,{Classes,}windows,dialogs;

function GETDATE2:string;
function GETTIME2(d,d2:string):string;

function hextoint(what:string):integer;
function readlnTrimUpperCase(var f:text):string;
function readlnParam(var f:text;param:string;trimuppercase:boolean):string;
function getWord(S:string; n:integer; DL:string=' '):string;
function getWordCount(S:string; DL:string=' '):integer;

function getbit16(num:word; bit:byte):boolean;
procedure SetBit16(var AWord: word; ABit: byte; AState: boolean = true);
function strbit16(num:word):string;
function strbit8(num:byte):string;

implementation



function GETDATE2:string;
var tme:SYSTEMTIME;
begin
GETLOCALTIME(tme);
result:=IntToStr(tme.wYear)+'-'+
               IntToStr(tme.wMonth)+'-'+
               IntToStr(tme.wDay);


end;

function GETTIME2(d,d2:string):string;
var tme:SYSTEMTIME;
begin
GETLOCALTIME(tme);
result:=IntToStr(tme.wHour)+d+
                 IntToStr(tme.wMinute)+d+
                 IntToStr(tme.wSecond){+d2+
                 IntToStr(tme.wMilliseconds)};
end;


function getbit16(num:word; bit:byte):boolean;
begin
 if ((num shr bit) and 1)=1 then result:=true
  else result:=false;
end;


procedure SetBit16(var AWord: word; ABit: byte; AState: boolean = true);
var zresult:integer;
begin
  if AState then
    zResult := AWord or (1 shl ABit)
  else
    zResult := AWord and (not (1 shl ABit));
AWord:=zResult;
end;

function strbit16(num:word):string;
var tempstr:string;
i:integer;
begin
 tempstr:='';
 for i:=15 downto 0 do
  if getbit16(num, i) then tempstr:=tempstr+' 1'
   else  tempstr:=tempstr+' 0';
result:=tempstr;
end;

function strbit8(num:byte):string;
var tempstr:string;
i:integer;
begin
 tempstr:='';
 for i:=7 downto 0 do
  if getbit16(word(num), i) then tempstr:=tempstr+' 1'
   else  tempstr:=tempstr+' 0';
result:=tempstr;
end;




function hextoint(what:string):integer;
  var i,cte:integer;
  var tempRes:integer;
const  Convert: array['0'..'f'] of SmallInt =
    ( 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,-1,-1,-1,-1,-1,-1,
     -1,10,11,12,13,14,15,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     -1,10,11,12,13,14,15);
begin
  tempRes:=0;
  cte:=length(what);

  for i:=0 to cte-1 do
   tempRes:=tempRes+((Convert[what[i+1]]) shl (4*(cte-1-i)));

  result:=tempRes;

end;

function readlnTrimUpperCase(var f:text):string;
var s:string;
begin
     readln(f,s);
     s:=trim( s );
     s:=upperCase(s);
     result:=s;
end;


function readlnParam(var f:text;param:string;trimuppercase:boolean):string;
var s:string;
begin

if trimuppercase then
 repeat
  s:=readlnTrimUpperCase(f);
 until ((getword(s,1)=param)or eof(f))
else
 repeat
  readln(f,s);
 until ((getword(s,1)=param)or eof(f)); // eof?

result:=s;
end;


function getWord(S:string; n:integer; DL:string=' '):string;
var ns,fnd:string;
    a,i:integer;
begin
ns:=s+DL;
for i:=1 to n do
 begin
  a:=pos(dl,ns);
  if a>0 then
   begin
    fnd:=copy(ns,1,a-1);

    delete(ns,1,a{}+length(dl)-1{});

   end;
 end;
result:=fnd;

end;

function getWordCount(S:string; DL:string=' '):integer;
var ns:string;
var i,b:integer;
begin

 ns:=s+DL;
 b:=0;
 for i:=1 to length(ns) do
  if ns[i]=DL then inc(b);

if trim(s)='' then b:=0;
 

 result:=b;
end;

end.
