// tmtlib@narod.ru

unit sendget;

interface

uses Windows,Classes,MyStrTool,SysUtils,dialogs;




  type TBufferx=packed array[0..1600*1201+128-1] of byte;
  type PBuffer=^TBufferx;


type TCOMPort = class(TComponent)
 private

    _hPort:THandle;
    _MyCommTimeouts : TCommTimeouts;
    _MyDCB          : TDCB;

   _SendLen:integer;
   _nSent:Cardinal;

   _NeedGetLen:integer;
   _BytesTrans:Cardinal;
   _opened:boolean;







 public
    _Port:integer;
    _Speed:Cardinal;
 constructor Create;

 function ComSendGet( SendStr:string;
                      sendget:PBuffer;
                      NeedGetLen:integer;
                      TimeOut:integer=1000):boolean;

 function ComSendGetB( sendget:PBuffer;
                       SendLen:integer;
                       NeedGetLen:integer;
                       TimeOut:integer=1000):boolean;


   function ComSpeed(spd:cardinal):boolean;
   function ComPort(prt:integer):boolean;
   function Purge:boolean;


end;




implementation




constructor TComPort.Create;
begin
 _hPort:=invalid_handle_value;
 _opened:=false;
end;

function TComPort.ComSpeed(spd:cardinal):boolean;
begin

result:=true;

if _opened=true then
 begin
  result:=closeHandle(_hPort);
  _opened:=false;
 end;

 _speed:=spd;
end;

function TComPort.ComPort(prt:integer):boolean;
begin
result:=true;

if _opened=true then
 begin
  sleep(2500);
  result:=closeHandle(_hPort);
  _opened:=false;
 end;

_port:=prt;
end;


function TComPort.Purge:boolean;
var xbyte:byte;
begin
result:=true;

if _opened=true then
 begin
    result:=PurgeComm(_hPort, PURGE_TXABORT or PURGE_RXABORT or PURGE_TXCLEAR or PURGE_RXCLEAR);
    while ComSendGet('',@xbyte,1,10) do sleep(1);
 end;

end;


function TComPort.ComSendGet( SendStr:string;
                              sendget:PBuffer;
                              NeedGetLen:integer;
                              TimeOut:integer=1000):boolean;
var i:integer;

begin

 _SendLen:=getWordCount(SendStr);

 for i := 0 to _SendLen-1 do
  sendget^[i]:= HexToInt(getWord(SendStr,i+1));

  result:=ComSendGetB(sendget,_SendLen,NeedGetLen,TimeOut);

end;


function TComPort.ComSendGetB( sendget:PBuffer;
                               SendLen:integer;
                               NeedGetLen:integer;
                               TimeOut:integer=1000):boolean;
begin

 _SendLen:=SendLen;

 result:=true;


  if not _opened then
   begin

  _hPort := CreateFile(PChar('\\.\COM'+IntToStr(_Port)),
                      GENERIC_READ or GENERIC_WRITE,
                      0, nil,
                      OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);

  if _hPort=invalid_handle_value then
   begin
    result:=false;
    exit;
   end;                     


 _MycommTimeouts.ReadIntervalTimeout := 0;
 _MycommTimeouts.ReadTotalTimeoutMultiplier := 2; // 1000/960= 1ms
 _MycommTimeouts.ReadTotalTimeoutConstant := timeOut;
 _MycommTimeouts.WriteTotalTimeoutMultiplier := 0;
 _MycommTimeouts.WriteTotalTimeoutConstant:= 0;

 SetCommTimeouts(_hPort, _MyCommTimeouts);


 GetCommState(_hPort,_myDCB);
  FillChar(_myDCB, SizeOf(_myDCB), 0);
  _myDCB.DCBlength := SizeOf(_myDCB);
  if _speed=0 then showmessage('whe');
  
  _myDCB.BaudRate := _speed;
  _myDCB.ByteSize := 8;
  _myDCB.parity := NOPARITY;
  _myDCB.StopBits := ONESTOPBIT;
  _myDCB.Flags := $00000001;
 SetCommState(_hPort, _MyDCB);

  PurgeComm(_hPort, PURGE_TXABORT or PURGE_RXABORT or PURGE_TXCLEAR or PURGE_RXCLEAR);
   
 _opened:=true;
   end;

   if _opened and (_MycommTimeouts.ReadTotalTimeoutConstant<>timeOut) then
   begin

   _MycommTimeouts.ReadIntervalTimeout := 0;
   _MycommTimeouts.ReadTotalTimeoutMultiplier := 2;
   _MycommTimeouts.ReadTotalTimeoutConstant := timeOut;
   _MycommTimeouts.WriteTotalTimeoutMultiplier := 0;
   _MycommTimeouts.WriteTotalTimeoutConstant:= 0;

   SetCommTimeouts(_hPort, _MyCommTimeouts);

   end;
   






  if _opened then
   begin


  if not WriteFile(_hPort,
            SendGet^,
            _SendLen,
            _nSent,
            nil) then
             begin
              result:=false;
              exit;
             end;




 _BytesTrans:=0;
 _NeedGetLen:=NeedGetLen;

   if NeedGetLen>0 then
       if not ReadFile(_hport,
                SendGet^,
                _NeedGetLen,
                _BytesTrans,
                 nil) then
                  begin
                   result:=false;
                   exit;
                  end;
          


if _BytesTrans<>_NeedGetLen then result:=false;
if _nSent<>_SendLen then result:=false;

   end;


end;


end.
